<?php
// PI_LCD_Library
// LCD Display Ansteuerung

// Includes
require_once('ALL_Constants.php');
require_once('PI_Library.php');

// Display in 4 bit Mode setzen
function LCD_init()
//initialisiert Display
{
	// verwendete Ports
	$ports = array(LCD_RS_line,LCD_RW_line,LCD_E_line,LCD_DATA4_line,LCD_DATA5_line,
					LCD_DATA6_line,LCD_DATA7_line);
	$max = count($ports);		// Schleifenzaeler
	for ($i=0;$i < $max;$i++)		// aktiviere und setze alle verwendeten Ports auf output
	{
		$erg = gpio_enable($ports[$i]);
		if ($erg != 'out')
		{
			if (!gpio_set_direction($ports[$i],'out'))
			{
				die ('ERROR set direction');
			}
		}
		// set output to low
		if (!gpio_set_value($ports[$i],'0'))
		{
			die ('ERROR setting value Port='.$i.$cr);
		}
	}
	
	LCD_send(LCD_CMD,0x33);		//LCD_FUNCTION_8BIT);
	usleep(4000);
	LCD_send(LCD_CMD,0x32);		//LCD_FUNCTION_8BIT);
	usleep((100));
	LCD_send(LCD_CMD,0x28);		//LCD_FUNCTION_8BIT);
	LCD_send(LCD_CMD,0xC);		//LCD_FUNCTION_4BIT);
	LCD_send(LCD_CMD,0x06);		//LCD_2_LINES);
	LCD_send(LCD_CMD,0x01);		//LCD_DISPLAY_OFF);
}


// Daten/Kommando an Daten sende senden
function LCD_send($c_d,$data)
{
	// vorerst RW fest auf Write und dafür Warteschleifen
	// warten auf Display ready
	//gpio_set_value(LCD_RW_line,LCD_READ);			// LCD auf lesen
	//while (gpio_get_value(LCD_BUSY_bit) != '0')		
	//{
		//Wait
	//}
	if ($c_d==LCD_CHR)
	{
		$data = ord($data);
	}
//	gpio_set_value(LCD_RW_line,LCD_WRITE);		// LCD auf schreibe

	gpio_set_value(LCD_RS_line,$c_d);			// Data /command Mode setzen
	$high = $data & 0xF0;						// oberes Nible maskieren
	$high = $high >> 4;							// nach unten schieben
	$low = $data & 0x0F;						// unteres Nibble maskieren
	// oberse Nibble ausgeben
	LCD_set_data($high);						// Wert an Datenleitungen legen
	usleep(500);
	// Write Pulse
	gpio_set_value(LCD_E_line,'1');				// activ high
	usleep(500);
	gpio_set_value(LCD_E_line,'0');				// inactiv
	// unteres Nibble ausgeben
	LCD_set_data($low);							// Wert an Datenleitungen legen
	usleep(500);
	// write Pulse
	gpio_set_value(LCD_E_line,'1');				// activ high
	usleep(500);
	gpio_set_value(LCD_E_line,'0');				// inactiv
}

// Daten an Display
function LCD_set_data($data)
{
	// in 4 bit Mode wird zuerst das obere Nibble uebertragen
	$ports = array(LCD_DATA4_line,LCD_DATA5_line,LCD_DATA6_line,LCD_DATA7_line);	// Ports der PI
	
	for ($i=0; $i<4; $i++)				// Data Ports setzen
	{
			$d = $data & 0x01;
			$pin = $ports[$i];
			if ($d == 0)
			{
				$pd = '0';
			}
			else 
			{
				$pd = '1';
			}
			gpio_set_value($pin,$pd);
			$data = $data >> 1;
	}
}

function LCD_write_line($line,$message)
// Zeichenkette senden
{
		// Selecet line
		if ($line==1)
		{
			LCD_send(LCD_CMD,LCD_LINE_1);
		}
		else 
		{
			LCD_send(LCD_CMD,LCD_LINE_2);
		}
		// send message
		$len = strlen($message);
		for ($i=0; $i<$len; $i++)
		{
			LCD_send(LCD_CHR,$message[$i]);
		}
		// fill with blanks
		for ($i=$len; $i<LCD_WIDTH; $i++)
		{
			LCD_send(LCD_CHR,' ');
		}
}


?>